package net.sergeych.kiloparsec.adapter

import kotlinx.coroutines.channels.Channel
import kotlinx.coroutines.channels.ReceiveChannel
import kotlinx.coroutines.channels.SendChannel
import net.sergeych.kiloparsec.Transport

class ProxyDevice(
    inputChannel: Channel<UByteArray?>,
    outputChannel: Channel<UByteArray>,
    private val onClose: ()->Unit = {}): Transport.Device {

    override val input: ReceiveChannel<UByteArray?> = inputChannel
    override val output: SendChannel<UByteArray> = outputChannel
    override suspend fun close() {
        onClose()
    }
}